<template>
  <div
    v-if="!indexBlogI.IsHidden && sportsForDisplay.length > 0"
    class="h-[428px] w-screen ml-[calc(50%-50vw)] best-sport-container"
  >
    <div class="container mx-[auto] relative">
      <div class="sp-background">
        <div id="slider-sport-men" class="sport-men-image">
          <img
            id="best-sport-banner-1"
            class="img-slider active"
            :src="
              getAssetImage(
                `assets/theme/cool_88/desktop/home/best_sport_banner_1.png`
              )
            "
          />
          <img
            id="best-sport-banner-2"
            class="img-slider"
            :src="
              getAssetImage(
                `assets/theme/cool_88/desktop/home/best_sport_banner_2.png`
              )
            "
          />
          <img
            id="best-sport-banner-3"
            class="img-slider"
            :src="
              getAssetImage(
                `assets/theme/cool_88/desktop/home/best_sport_banner_3.png`
              )
            "
          />
        </div>
        <img
          :src="getAssetImage('assets/theme/common/images/best_sport_bg_1.png')"
          class="bg-transparent-w"
        />
      </div>
      <div class="grid grid-cols-2 pt-[64px] relative z-10">
        <div>
          <h2 class="title" style="color: var(--primary);">{{ indexBlogI.Text }}</h2>
          <div class="mt-[28px]">
            <c88d-button-with-person
              v-for="(sport, index) in sportsForDisplay"
              :key="index"
              class="mb-[20px]"
              :is-multiple-provider="providerCount[sport.GameProviderName] > 1"
              :class="{
                active: selectedGame && selectedGame.GameId === sport.GameId,
              }"
              :image-player="
                getAssetImage(
                  `assets/theme/cool_88/desktop/home/best_sport_icon_${
                    index + 1
                  }.png`
                )
              "
              :title="sport.GameProviderDisplayName"
              :text="sport.GameProviderDisplayName"
              @click="handleClick(sport, index)"
            />
          </div>
        </div>
        <div class="ml-[-23px]">
          <h2
            v-if="isRecommendMatchEnabled"
            class="title text-center pl-[20px]" style="color: var(--primary);"
          >
            {{ $t("upcoming_event") }}
          </h2>
          <div class="mt-[28px] flex gap-x-5">
            <div class="w-[160px]">
              <template
                v-if="
                  selectedGame && getProviderLogo(selectedGame.GameProviderName)
                "
              >
                <img
                  ref="rightLogo"
                  :src="getProviderLogo(selectedGame.GameProviderName)"
                  class="w-[129px]"
                />
                <div class="h-[90px] mt-[25px] text-[16px] leading-[19px] bk8-text">
                  {{
                    $t(
                      "enjoy_world_class_online_sports_book_with_the_best_odds"
                    )
                  }}
                </div>
                <nuxt-link
                  :to="
                    isAuthenticated
                      ? `/Game/${selectedGame.GameId}?tab=Sports&&entrance=${EnumEntranceLocation.GameLobby}`
                      : '/login'
                  "
                >
                  <el-button type="primary">{{ $t("play_now") }}</el-button>
                </nuxt-link>
              </template>
            </div>
            <div class="w-[444px] h-[208px] relative sport-game-popular-match">
              <sport-popular-match
                v-if="isRecommendMatchEnabled"
                variant="Carousel"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <template v-if="blogEntries.shouldShow()">
    <div
      class="bg-background5 w-screen py-[15px] flex justify-center ml-[calc(50%-50vw)]"
    >
      <div class="container mx-auto flex justify-center text-base">
        <div
          v-if="!blogEntries.blog21.content.IsHidden"
          class="mx-10 text-primary font-bold w-[144px] text-center"
        >
          <span v-html="blogEntries.blog21.content.Text"></span>
        </div>
        <div v-if="!blogEntries.blog22.isHidden()" class="flex">
          <el-divider
            v-if="!blogEntries.blog22.hideDivider()"
            direction="vertical"
          />
          <a :href="blogEntries.blog22.content.HyperLink">
            <div class="flex items-center w-[159px] mx-10 justify-center">
              <img
                class="object-cover h-[35px] pr-2.5"
                :src="blogEntries.blog22.blog.ImagePath"
              />
              <div class="text-white text-left bk8-customText">
                <div>{{ blogEntries.blog22.blog.Text }}</div>
                <div>{{ blogEntries.blog22.content.Text }}</div>
              </div>
            </div>
          </a>
        </div>
        <div
          v-if="
            !blogEntries.blog23.blog.IsHidden &&
            !blogEntries.blog23.content.IsHidden
          "
          class="flex"
        >
          <el-divider
            v-if="!blogEntries.blog23.hideDivider()"
            direction="vertical"
          />
          <a :href="blogEntries.blog23.content.HyperLink">
            <div class="flex items-center w-[144px] mx-10">
              <img
                class="object-cover h-[35px] pr-2.5"
                :src="blogEntries.blog23.blog.ImagePath"
              />
              <div class="text-left text-white bk8-customText">
                <div>{{ blogEntries.blog23.blog.Text }}</div>
                <div class="text-primary font-bold underline">
                  {{ blogEntries.blog23.content.Text }}
                </div>
              </div>
            </div>
          </a>
        </div>
      </div>
    </div>
  </template>
</template>

<script lang="ts">
import { defineComponent, ref, computed, PropType, reactive, watch } from "vue";
import _ from "lodash";
import C88dButtonWithPerson from "./C88dButtonWithPerson.client.vue";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import commonHelper from "@/utils/commonHelper";
import { GameBsi } from "@/models/bsiGameList";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import textHelper from "@/utils/formatHelpers/textFormatHelper";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import { gameStore } from "~~/store/game";

export default defineComponent({
  components: {
    C88dButtonWithPerson,
  },
  props: {
    indexBlogI: {
      type: Object as PropType<IThemePropertiesFromApi>,
      required: true,
    },
  },
  setup() {
    const { getAssetImage } = commonHelper;
    const rightLogo = ref<Element | undefined>();
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const games = computed(() =>
      gameStore.state.games
        .filter((game) => game.ForDesktop)
        .map((item) => new GameBsi(item))
    );
    const indexBlog22 = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_2_2"
        )
    );
    const indexBlog23 = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_2_3"
        )
    );
    const indexBlogContent21 = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_content_2_1"
        )
    );
    const indexBlogContent22 = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_content_2_2"
        )
    );
    const indexBlogContent23 = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_content_2_3"
        )
    );
    const isIndexBlog2Hidden = computed(
      (): boolean =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_2"
        ).IsHidden
    );

    const blogEntries = reactive({
      blog21: {
        blog: undefined,
        content: indexBlogContent21,
      },
      blog22: {
        blog: indexBlog22,
        content: indexBlogContent22,
        isHidden: () =>
          blogEntries.blog22.blog.IsHidden ||
          blogEntries.blog22.content.IsHidden,
        hideDivider: () => blogEntries.blog21.content.IsHidden,
      },
      blog23: {
        blog: indexBlog23,
        content: indexBlogContent23,
        isHidden: () =>
          blogEntries.blog23.blog.IsHidden ||
          blogEntries.blog23.content.IsHidden,
        hideDivider: () =>
          blogEntries.blog21.content.IsHidden && blogEntries.blog22.isHidden(),
      },
      shouldShow: () => {
        if (isIndexBlog2Hidden.value) return false;
        if (
          blogEntries.blog21.content.IsHidden &&
          blogEntries.blog22.isHidden() &&
          blogEntries.blog23.isHidden()
        )
          return false;
        return true;
      },
    });

    const isAuthenticated = computed(() => store.state.auth);
    const isRecommendMatchEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "sportsbook_recommend_matches"
        ).IsHidden
    );
    const sabaBg = `url(${getAssetImage(
      "assets/theme/common/images/best_sport_bg.png"
    )})`;
    const providerFeature = computed(() => store.state.gameProviders.Games);
    const sportGameProvider = _.uniqBy(
      providerFeature.value?.filter(
        (item) => _.toUpper(item.TabType) === _.toUpper("sports")
      ),
      "GameProviderName"
    );
    const sportsForDisplay = computed(() => {
      const sports = sportGameProvider;
      if (sports.length > 3) return sports.slice(0, 3);
      return sports;
    });
    const selectedGame = ref<IGame | undefined>(
      _.first(sportsForDisplay.value)
    );

    const getProviderLogo = (providerName: string): string => {
      try {
        const converted = textHelper.convertString(providerName, true);
        const fileName = `provider_logo_${converted}.png`;
        return getAssetImage(
          `assets/theme/cool_88/desktop/logos/providers/${fileName}`
        );
      } catch (error) {
        return "";
      }
    };
    const handleSlider = (index: number): void => {
      const selectedSlide = document.getElementById(
        `best-sport-banner-${index}`
      );
      if (!selectedSlide || selectedSlide.classList.contains("active")) return;

      const currentActiveSlides = document.querySelectorAll(
        "img.img-slider.active"
      );
      currentActiveSlides.forEach((activeSlide) => {
        activeSlide.classList.remove("active", "fade-in");
        activeSlide.classList.add("fade-out");
      });
      selectedSlide.classList.add("active", "fade-in");
    };
    const handleClick = (sport: IGame, index: number) => {
      selectedGame.value = sport;
      handleSlider(index + 1);
    };
    const providerCount = textHelper.checkMultiple(sportsForDisplay.value);
    const animateFadeIn = (
      element: Element | null | undefined,
      duration = 0.4
    ): void => {
      if (!element) return;
      element.classList.add("logoFadeIn");
      setTimeout(() => {
        element.classList.remove("logoFadeIn");
      }, duration * 1000);
    };
    const handleActiveBtnChange = async (): Promise<void> => {
      if (!selectedGame.value) return;

      if (rightLogo.value) {
        animateFadeIn(rightLogo.value);
      }
    };
    watch(() => selectedGame.value, handleActiveBtnChange);

    return {
      rightLogo,
      blogEntries,
      EnumEntranceLocation,
      isAuthenticated,
      isIndexBlog2Hidden,
      isRecommendMatchEnabled,
      sabaBg,
      selectedGame,
      sportsForDisplay,
      getAssetImage,
      getProviderLogo,
      handleClick,
      providerCount,
    };
  },
});
</script>

<style scoped lang="scss">
.el-divider--vertical {
  height: 100%;
  border-left: 1px solid var(--primary);
  margin: 0;
}
.best-sport-container {
  background-image: v-bind(sabaBg);
  font-family: "Roboto";
  margin-top: 40px;
  color: var(--text5);
  padding-left: 1rem;
  padding-right: 1rem;
  overflow: hidden;
  position: relative;
  background-repeat: round;
}

.sp-background {
  > .sport-men-image {
    position: absolute;
    z-index: 0;
    height: 428px;
    overflow: visible;
    width: 100%;

    > img {
      position: absolute;

      &.active {
        opacity: 1;
        transform: translateX(100px);
      }
      &:not(.active) {
        opacity: 0;
      }
    }
  }

  > .bg-transparent-w {
    position: absolute;
    z-index: 1;
    left: 488px;
  }
}

h2.title {
  font-weight: 800;
  font-size: 24px;
  line-height: 28px;
  color: var(--secondary);
}

.el-button {
  width: 160px;
  height: 36px;
  margin-top: 15px;
}
.fade-out {
  animation: fade-out 0.5s forwards;
  animation-iteration-count: 1;
}

.fade-in {
  animation: fade-in 1s forwards;
  animation-iteration-count: 1;
  transition: all 1s ease;
}

@keyframes fade-out {
  0% {
    transform: translateX(100px);
    opacity: 1;
  }

  99% {
    transform: translateX(150px);
    opacity: 0;
  }

  100% {
    transform: translateX(0px);
    opacity: 0;
  }
}

@keyframes fade-in {
  0% {
    transform: translateX(-50vw);
    opacity: 0;
  }

  50% {
    transform: translateX(120px);
    opacity: 1;
  }
  100% {
    transform: translateX(100px);
    opacity: 1;
  }
}
@keyframes logoFadeIn {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

.logoFadeIn {
  animation: logoFadeIn 0.4s ease-in-out forwards;
}
:deep(.sport-game-popular-match .popular-match-card-desktop) {
  width: 360px;
}
[theme-color="bk8"] .bk8-text,
[theme-color="bk8_blue"] .bk8-text {
  color: rgba(255, 255, 255, 1);
}
[theme-color="bk8"] .bk8-customText,
[theme-color="bk8_blue"] .bk8-customText {
 color: var(--text5);
}
</style>
